
/*
 * $Id: HoCoDistr.h,v 1.1.2.1 1999/02/16 03:43:35 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef HO_CO_DISTR_H
#define HO_CO_DISTR_H

#include "OidDistr.h"
#include "History.h"

// "Hot&Cold" Object Id distribution
// supports notions of Hot and Cold oid sets
class HoCoDistr: public OidDistr {
	public:
		HoCoDistr(RndGen *aGen, double aHitR, double aHotR, double aColdR, int aHotSize);

		virtual int genOid();

		virtual const char *pdfName() const { return "HoCo"; }
		virtual ostream &print(ostream &os) const;

	protected:
		int genColdMiss();
		int genWarmMiss();
		int genHotHit();
		int genWarmHit();
		int repeat(int firstId, int lastId);

	protected:
		double theHotRatio;
		double theColdRatio;
		double theNotColdRatio; // optimization: 1 - theColdRatio
		int theHotSize;

		History<int> theHistory;
		RndDistr *theRepDistance; // distance between hits
		int theSearchDelta;       // best fit search space for hits

		int theMaxHotOid;
		int theLastHotOid;
		int theLastWarmOid;
		int theLastColdOid;
};

#endif
